﻿using ProjectByldozer.Entities;

namespace ProjectByldozer.Drawnings;

/// <summary>
/// Класс, отвечающий за прорисовку и перемещение объекта-сущности
/// </summary>
public class DrawningByldozer : DrawningTrackedCar
{

    /// <summary>
    /// конструктор
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="dump">Признак наличия отвала</param>
    /// <param name="bakingpowder">Признак наличия разрыхлитель</param>
    /// <param name="pipe">Признак наличия трубы</param>
    public DrawningByldozer(int speed, double weight, Color bodyColor, Color additionalColor, bool dump, bool bakingpowder, bool pipe) : base(150, 80)
    {
        EntityTrackedCar = new EntityByldozer(speed, weight, bodyColor, additionalColor, dump, bakingpowder, pipe);
    }
    /// <summary>
    /// Конструктор для 
    /// </summary>
    /// <param name="speed"></param>
    /// <param name="weight"></param>
    /// <param name="bodyColor"></param>
    /// <param name="additionalColor"></param>
    /// <param name="pin"></param>
    /// <param name="rokets"></param>
    /// <param name="symbolism"></param>
    public DrawningByldozer(EntityTrackedCar entityTrackedCar)
    {
        if (entityTrackedCar != null)
        {
            EntityTrackedCar = entityTrackedCar;
        }
    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityTrackedCar == null || EntityTrackedCar is not EntityByldozer byldozer || !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }


        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(byldozer.AdditionalColor);

        ///труба
        if (byldozer.Pipe)
        {
            g.DrawRectangle(pen, _startPosX.Value + 60, _startPosY.Value, 5, 20);
            g.FillRectangle(additionalBrush, _startPosX.Value + 60, _startPosY.Value, 5, 20);
        }
    
        _startPosX += 30;
        _startPosY += 5;
        base.DrawTransport(g);
        _startPosX -= 30;
        _startPosY -= 5;

       
        // отвал
        if (byldozer.Dump)

        {
            Point point1 = new Point(_startPosX.Value + 30, _startPosY.Value + 35);
            Point point2 = new Point(_startPosX.Value + 25, _startPosY.Value + 35);
            Point point4 = new Point(_startPosX.Value + 25, _startPosY.Value + 23);
            Point point5 = new Point(_startPosX.Value + 20, _startPosY.Value + 23);
            Point point6 = new Point(_startPosX.Value + 15, _startPosY.Value + 60);
            Point point7 = new Point(_startPosX.Value + 2, _startPosY.Value + 80);
            Point point8 = new Point(_startPosX.Value + 25, _startPosY.Value + 80);
            Point point9 = new Point(_startPosX.Value + 25, _startPosY.Value + 46);
            Point point10 = new Point(_startPosX.Value + 30, _startPosY.Value + 46);

            Point[] Dump = { point1, point2, point4, point5, point6, point7, point8, point9, point10 };
            g.FillPolygon(additionalBrush, Dump);
        }

        if (byldozer.Bakingpowder)

        {
            Point point1 = new Point(_startPosX.Value + 131, _startPosY.Value + 25);
            Point point2 = new Point(_startPosX.Value + 150, _startPosY.Value + 25);
            Point point4 = new Point(_startPosX.Value + 150, _startPosY.Value + 35);
            Point point5 = new Point(_startPosX.Value + 147, _startPosY.Value + 35);
            Point point6 = new Point(_startPosX.Value + 147, _startPosY.Value + 60);
            Point point7 = new Point(_startPosX.Value + 144, _startPosY.Value + 60);
            Point point8 = new Point(_startPosX.Value + 145, _startPosY.Value + 80);
            Point point9 = new Point(_startPosX.Value + 137, _startPosY.Value + 60);
            Point point10 = new Point(_startPosX.Value + 134, _startPosY.Value + 60);
            Point point11 = new Point(_startPosX.Value + 134, _startPosY.Value + 35);

            Point point12 = new Point(_startPosX.Value + 131, _startPosY.Value + 35);


            Point[] Bakingpowder = { point1, point2, point4, point5, point6, point7, point8, point9, point10, point11, point12 };
            g.FillPolygon(additionalBrush, Bakingpowder);
        }
            
    }
}
