﻿
using ProjectByldozer.MovementStrategy;

namespace ProjectSportCar.MovementStrategy;

public class MoveToBorder : AbstractStrategy
{
    protected override bool IsTargetDestinaion()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return false;
        }
        //// достиг ли объект правой границы поля и нижней границы поля или выходит за нее после выполнения шага. 
        return objParams.RightBorder + GetStep() >= FieldWidth && objParams.DownBorder + GetStep() >= FieldHeight;
    }

    protected override void MoveToTarget()
    {
        ///параметры объекта
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return;
        }

        int diffX = objParams.RightBorder - FieldWidth;
        if (Math.Abs(diffX) > GetStep())// Проверяем, превышает ли абсолютное значение разницы по оси X значение шага
        {
            if (diffX > 0) MoveLeft();
            else MoveRight();
        }
        int diffY = objParams.DownBorder - FieldHeight;///Проверяем, превышает ли абсолютное значение разницы по оси Y значение шага
        if (Math.Abs(diffY) > GetStep())
        {
            if (diffY > 0) MoveUp();
            else MoveDown();
        }
    }
}